Index: /LMDZ4/trunk/libf/phylmd/write_histISCCP.h
===================================================================
--- /LMDZ4/trunk/libf/phylmd/write_histISCCP.h	(revision 765)
+++ /LMDZ4/trunk/libf/phylmd/write_histISCCP.h	(revision 766)
@@ -15,16 +15,16 @@
         DO k=1,kmaxm1
          zx_tmp_fi3d(1:klon, 1:lmaxm1)=fq_isccp(1:klon,k,1:lmaxm1,n)*100.
-         CALL gr_fi_ecrit(lmaxm1,klon,iim,jjmp1,zx_tmp_fi3d,
-     .                    zx_tmp_3d)
+cym         CALL gr_fi_ecrit(lmaxm1,klon,iim,jjmp1,zx_tmp_fi3d,
+cym     .                    zx_tmp_3d)
 c
 cIM: champ 3d : (lon,lat,pres) pour un tau fixe
 c
-         CALL histwrite(nid_isccp,"cldISCCP_"//taulev(k)//typinout(n),
-     .                  itau_w,zx_tmp_3d,iim*jjmp1*lmaxm1,ndex3d)
+       CALL histwrite_phy(nid_isccp,"cldISCCP_"//taulev(k)//typinout(n),
+     .                  itau_w,zx_tmp_fi3d)
         ENDDO !k
 c
-        CALL gr_fi_ecrit(1, klon,iim,jjmp1,nbsunlit(1,:,n),zx_tmp_2d)
-        CALL histwrite(nid_isccp,"nsunlit"//typinout(n),itau_w,
-     .                 zx_tmp_2d,iim*jjmp1,ndex2d)
+cym        CALL gr_fi_ecrit(1, klon,iim,jjmp1,nbsunlit(1,:,n),zx_tmp_2d)
+        CALL histwrite_phy(nid_isccp,"nsunlit"//typinout(n),itau_w,
+     .                 nbsunlit(1,:,n))
 c
         ENDDO ! n=1, napisccp
@@ -50,25 +50,25 @@
           ENDDO
          ENDIF
-         CALL gr_fi_ecrit(1,klon,iim,jjmp1,fq_is_true,
-     .                    zx_tmp_2d)
+cym         CALL gr_fi_ecrit(1,klon,iim,jjmp1,fq_is_true,
+cym     .                    zx_tmp_2d)
 c
 cIM: champ 2d : (lon,lat) pour un tau et une pc fixes
 c
-         CALL histwrite(nid_isccp,pclev(l)//taulev(k)//typinout(n),
-     .                  itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
+         CALL histwrite_phy(nid_isccp,pclev(l)//taulev(k)//typinout(n),
+     .                  itau_w,fq_is_true(:,:,l,n))
          ENDDO !l
         ENDDO !k
 c
 c       print*,'n=',n,' write_ISCCP avant nbsunlit'
-        CALL gr_fi_ecrit(1, klon,iim,jjmp1,nbsunlit(1,:,n),zx_tmp_2d)
-        CALL histwrite(nid_isccp,"nsunlit"//typinout(n),
-     .                 itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
+cym        CALL gr_fi_ecrit(1, klon,iim,jjmp1,nbsunlit(1,:,n),zx_tmp_2d)
+        CALL histwrite_phy(nid_isccp,"nsunlit"//typinout(n),
+     .                 itau_w,nbsunlit(1,:,n))
 c
         zx_tmp_fi2d(1:klon)=float(seed(1:klon,n))
 c
 c       print*,'n=',n,' write_ISCCP avant seed'
-        CALL gr_fi_ecrit(1, klon,iim,jjmp1,zx_tmp_fi2d,zx_tmp_2d)
-        CALL histwrite(nid_isccp,"seed"//verticaxe(n),
-     .                 itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
+cym        CALL gr_fi_ecrit(1, klon,iim,jjmp1,zx_tmp_fi2d,zx_tmp_2d)
+        CALL histwrite_phy(nid_isccp,"seed"//verticaxe(n),
+     .                 itau_w,zx_tmp_fi2d)
 c
 c 9types de nuages ISCCP-D2
@@ -80,7 +80,6 @@
      $  fq_is_true(i,1,3,n)+ fq_is_true(i,2,3,n)+ fq_is_true(i,3,3,n) )
         ENDDO
-        CALL gr_fi_ecrit(1, klon,iim,jjmp1,zx_tmp_fi2d,zx_tmp_2d)
-        CALL histwrite(nid_isccp,"cirr",itau_w,zx_tmp_2d,
-     $  iim*jjmp1,ndex2d)
+cym       CALL gr_fi_ecrit(1, klon,iim,jjmp1,zx_tmp_fi2d,zx_tmp_2d)
+        CALL histwrite_phy(nid_isccp,"cirr",itau_w,zx_tmp_fi2d)
 c
         DO i=1, klon
@@ -90,7 +89,6 @@
      $   fq_is_true(i,4,3,n)+ fq_is_true(i,5,3,n) )
         ENDDO
-	CALL gr_fi_ecrit(1, klon,iim,jjmp1,zx_tmp_fi2d,zx_tmp_2d)
-        CALL histwrite(nid_isccp,"cist",itau_w,zx_tmp_2d,
-     $  iim*jjmp1,ndex2d)
+cym	CALL gr_fi_ecrit(1, klon,iim,jjmp1,zx_tmp_fi2d,zx_tmp_2d)
+        CALL histwrite_phy(nid_isccp,"cist",itau_w,zx_tmp_fi2d)
 c
         DO i=1, klon
@@ -100,7 +98,6 @@
      $   fq_is_true(i,6,3,n)+ fq_is_true(i,7,3,n) )
         ENDDO
-	CALL gr_fi_ecrit(1, klon,iim,jjmp1,zx_tmp_fi2d,zx_tmp_2d)
-        CALL histwrite(nid_isccp,"deep",itau_w,zx_tmp_2d,
-     $  iim*jjmp1,ndex2d)
+cym	CALL gr_fi_ecrit(1, klon,iim,jjmp1,zx_tmp_fi2d,zx_tmp_2d)
+        CALL histwrite_phy(nid_isccp,"deep",itau_w,zx_tmp_fi2d)
 c
         DO i=1, klon
@@ -109,7 +106,6 @@
      $  fq_is_true(i,1,5,n)+ fq_is_true(i,2,5,n)+ fq_is_true(i,3,5,n) )
         ENDDO
-	CALL gr_fi_ecrit(1, klon,iim,jjmp1,zx_tmp_fi2d,zx_tmp_2d)
-        CALL histwrite(nid_isccp,"alcu",itau_w,zx_tmp_2d,
-     $  iim*jjmp1,ndex2d)
+cym	CALL gr_fi_ecrit(1, klon,iim,jjmp1,zx_tmp_fi2d,zx_tmp_2d)
+        CALL histwrite_phy(nid_isccp,"alcu",itau_w,zx_tmp_fi2d)
 c
         DO i=1, klon
@@ -118,7 +114,6 @@
      $   fq_is_true(i,4,5,n)+ fq_is_true(i,5,5,n) )
         ENDDO
-	CALL gr_fi_ecrit(1, klon,iim,jjmp1,zx_tmp_fi2d,zx_tmp_2d)
-        CALL histwrite(nid_isccp,"alst",itau_w,zx_tmp_2d,
-     $  iim*jjmp1,ndex2d)
+cym	CALL gr_fi_ecrit(1, klon,iim,jjmp1,zx_tmp_fi2d,zx_tmp_2d)
+        CALL histwrite_phy(nid_isccp,"alst",itau_w,zx_tmp_fi2d)
 c
         DO i=1, klon
@@ -127,7 +122,6 @@
      $   fq_is_true(i,6,5,n)+ fq_is_true(i,7,5,n) )
         ENDDO
-	CALL gr_fi_ecrit(1, klon,iim,jjmp1,zx_tmp_fi2d,zx_tmp_2d)
-        CALL histwrite(nid_isccp,"nist",itau_w,zx_tmp_2d,
-     $  iim*jjmp1,ndex2d)
+cym	CALL gr_fi_ecrit(1, klon,iim,jjmp1,zx_tmp_fi2d,zx_tmp_2d)
+        CALL histwrite_phy(nid_isccp,"nist",itau_w,zx_tmp_fi2d)
 c
         DO i=1, klon
@@ -136,7 +130,6 @@
      $  fq_is_true(i,1,7,n)+ fq_is_true(i,2,7,n)+ fq_is_true(i,3,7,n) )
         ENDDO
-	CALL gr_fi_ecrit(1, klon,iim,jjmp1,zx_tmp_fi2d,zx_tmp_2d)
-        CALL histwrite(nid_isccp,"cumu",itau_w,zx_tmp_2d,
-     $  iim*jjmp1,ndex2d)
+cym	CALL gr_fi_ecrit(1, klon,iim,jjmp1,zx_tmp_fi2d,zx_tmp_2d)
+        CALL histwrite_phy(nid_isccp,"cumu",itau_w,zx_tmp_fi2d)
 c
         DO i=1, klon
@@ -145,7 +138,6 @@
      $   fq_is_true(i,4,7,n)+ fq_is_true(i,5,7,n) )
         ENDDO
-	CALL gr_fi_ecrit(1, klon,iim,jjmp1,zx_tmp_fi2d,zx_tmp_2d)
-        CALL histwrite(nid_isccp,"stcu",itau_w,zx_tmp_2d,
-     $  iim*jjmp1,ndex2d)
+cym	CALL gr_fi_ecrit(1, klon,iim,jjmp1,zx_tmp_fi2d,zx_tmp_2d)
+        CALL histwrite_phy(nid_isccp,"stcu",itau_w,zx_tmp_fi2d)
 c
         DO i=1, klon
@@ -154,7 +146,6 @@
      $   fq_is_true(i,6,7,n)+ fq_is_true(i,7,7,n) )
         ENDDO
-	CALL gr_fi_ecrit(1, klon,iim,jjmp1,zx_tmp_fi2d,zx_tmp_2d)
-        CALL histwrite(nid_isccp,"stra",itau_w,zx_tmp_2d,
-     $  iim*jjmp1,ndex2d)
+cym	CALL gr_fi_ecrit(1, klon,iim,jjmp1,zx_tmp_fi2d,zx_tmp_2d)
+        CALL histwrite_phy(nid_isccp,"stra",itau_w,zx_tmp_fi2d)
 c
 c 3_tau_nuages x 3_levels
@@ -172,7 +163,6 @@
      $  fq_is_true(i,1,7,n)+ fq_is_true(i,2,7,n)+ fq_is_true(i,3,7,n) )
         ENDDO   
-        CALL gr_fi_ecrit(lmax3,klon,iim,jjmp1,cld_fi3d,cld_3d)
-        CALL histwrite(nid_isccp,"thin",itau_w,cld_3d,
-     $  iim*jjmp1*lmax3,ndex3d)
+cym        CALL gr_fi_ecrit(lmax3,klon,iim,jjmp1,cld_fi3d,cld_3d)
+        CALL histwrite_phy(nid_isccp,"thin",itau_w,cld_fi3d)
 c
         DO i=1, klon
@@ -188,7 +178,6 @@
      $    fq_is_true(i,4,7,n)+ fq_is_true(i,5,7,n) )
 	ENDDO   
-        CALL gr_fi_ecrit(lmax3, klon,iim,jjmp1,cld_fi3d,cld_3d)
-        CALL histwrite(nid_isccp,"mid",itau_w,cld_3d,
-     $  iim*jjmp1*lmax3,ndex3d)
+cym       CALL gr_fi_ecrit(lmax3, klon,iim,jjmp1,cld_fi3d,cld_3d)
+        CALL histwrite_phy(nid_isccp,"mid",itau_w,cld_fi3d)
 c
         DO i=1, klon
@@ -204,7 +193,6 @@
      $    fq_is_true(i,6,7,n)+ fq_is_true(i,7,7,n) )
         ENDDO   
-        CALL gr_fi_ecrit(lmax3, klon,iim,jjmp1,cld_fi3d,cld_3d)
-        CALL histwrite(nid_isccp,"thick",itau_w,cld_3d,
-     $  iim*jjmp1*lmax3,ndex3d)
+cym       CALL gr_fi_ecrit(lmax3, klon,iim,jjmp1,cld_fi3d,cld_3d)
+        CALL histwrite_phy(nid_isccp,"thick",itau_w,cld_fi3d)
 c
         ENDDO ! n=1, napisccp
@@ -213,5 +201,7 @@
 c
        if (ok_sync) then
+c$OMP MASTER
         call histsync(nid_isccp)
+c$OMP END MASTER       
        endif
 
Index: /LMDZ4/trunk/libf/phylmd/write_histREGDYN.h
===================================================================
--- /LMDZ4/trunk/libf/phylmd/write_histREGDYN.h	(revision 765)
+++ /LMDZ4/trunk/libf/phylmd/write_histREGDYN.h	(revision 766)
@@ -3,5 +3,8 @@
 !
       if (ok_regdyn) then
-c
+      
+      if (monocpu) then
+
+
       ndex3d = 0
       itau_w = itau_phy + itap
@@ -56,3 +59,5 @@
       endif
 
+      endif ! monocpu
+
       endif
Index: /LMDZ4/trunk/libf/phylmd/write_histday.h
===================================================================
--- /LMDZ4/trunk/libf/phylmd/write_histday.h	(revision 765)
+++ /LMDZ4/trunk/libf/phylmd/write_histday.h	(revision 766)
@@ -14,10 +14,8 @@
       IF(lev_histday.GE.1) THEN
 c
-       CALL gr_fi_ecrit(1,klon,iim,jjmp1,pphis,zx_tmp_2d)
-       CALL histwrite(nid_day,"phis",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-cIM 310804      CALL gr_fi_ecrit(1,klon,iim,jjmp1,paire,zx_tmp_2d)
-         CALL gr_fi_ecrit(1,klon,iim,jjmp1,airephy,zx_tmp_2d)
-       CALL histwrite(nid_day,"aire",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
+       CALL histwrite_phy(nid_day,"phis",itau_w,pphis)
+ 
+c
+       CALL histwrite_phy(nid_day,"aire",itau_w,airephy)
 c
       DO i=1, klon
@@ -25,50 +23,47 @@
       ENDDO
 c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, zx_tmp_fi2d, zx_tmp_2d)
-      CALL histwrite(nid_day,"contfracATM",itau_w,
-     $      zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-      CALL gr_fi_ecrit(1,klon,iim,jjmp1,pctsrf_new(:,is_ter),zx_tmp_2d)
-      CALL histwrite(nid_day,"contfracOR",itau_w,
-     $      zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, zxtsol,zx_tmp_2d)
-      CALL histwrite(nid_day,"tsol",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-C
-      CALL gr_fi_ecrit(1,klon,iim,jjmp1,zt2m,zx_tmp_2d)
-      CALL histwrite(nid_day,"t2m",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
+cym      CALL gr_fi_ecrit(1, klon,iim,jjmp1, zx_tmp_fi2d, zx_tmp_2d)
+      CALL histwrite_phy(nid_day,"contfracATM",itau_w,zx_tmp_fi2d)
+c
+cym      CALL gr_fi_ecrit(1,klon,iim,jjmp1,pctsrf_new(:,is_ter),zx_tmp_2d)
+      CALL histwrite_phy(nid_day,"contfracOR",itau_w,
+     &                   pctsrf_new(:,is_ter))
+c
+cym      CALL gr_fi_ecrit(1, klon,iim,jjmp1, zxtsol,zx_tmp_2d)
+      CALL histwrite_phy(nid_day,"tsol",itau_w,zxtsol)
+C
+cym      CALL gr_fi_ecrit(1,klon,iim,jjmp1,zt2m,zx_tmp_2d)
+      CALL histwrite_phy(nid_day,"t2m",itau_w,zt2m)
 c
 c   En attendant un eventuel debugage.
 
-      CALL gr_fi_ecrit(1,klon,iim,jjmp1,zt2m,zx_tmp_2d)
-      CALL histwrite(nid_day,"t2m_min",itau_w,zx_tmp_2d,
-     .               iim*jjmp1,ndex2d)
-c
-      CALL gr_fi_ecrit(1,klon,iim,jjmp1,zt2m,zx_tmp_2d)
-      CALL histwrite(nid_day,"t2m_max",itau_w,zx_tmp_2d,
-     .               iim*jjmp1,ndex2d)
+cym      CALL gr_fi_ecrit(1,klon,iim,jjmp1,zt2m,zx_tmp_2d)
+      CALL histwrite_phy(nid_day,"t2m_min",itau_w,zt2m)
+c
+cym      CALL gr_fi_ecrit(1,klon,iim,jjmp1,zt2m,zx_tmp_2d)
+      CALL histwrite_phy(nid_day,"t2m_max",itau_w,zt2m)
 c
       DO i = 1, klon
          zx_tmp_fi2d(i) = rain_lsc(i) + snow_lsc(i)
       ENDDO
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, zx_tmp_fi2d,zx_tmp_2d)
-      CALL histwrite(nid_day,"plul",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
+cym      CALL gr_fi_ecrit(1, klon,iim,jjmp1, zx_tmp_fi2d,zx_tmp_2d)
+      CALL histwrite_phy(nid_day,"plul",itau_w,zx_tmp_fi2d)
 c
       DO i = 1, klon
          zx_tmp_fi2d(i) = rain_con(i) + snow_con(i)
       ENDDO
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, zx_tmp_fi2d,zx_tmp_2d)
-      CALL histwrite(nid_day,"pluc",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, snow_lsc,zx_tmp_2d)
-      CALL histwrite(nid_day,"snowl",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
+cym      CALL gr_fi_ecrit(1, klon,iim,jjmp1, zx_tmp_fi2d,zx_tmp_2d)
+      CALL histwrite_phy(nid_day,"pluc",itau_w,zx_tmp_fi2d)
+c
+cym      CALL gr_fi_ecrit(1, klon,iim,jjmp1, snow_lsc,zx_tmp_2d)
+      CALL histwrite_phy(nid_day,"snowl",itau_w,snow_lsc)
 c
       IF(1.EQ.0) THEN
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, snow_con,zx_tmp_2d)
-      CALL histwrite(nid_day,"snowc",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
+cym      CALL gr_fi_ecrit(1, klon,iim,jjmp1, snow_con,zx_tmp_2d)
+      CALL histwrite_phy(nid_day,"snowc",itau_w,snow_con)
       ENDIF
 c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, zxfluxlat,zx_tmp_2d)
-      CALL histwrite(nid_day,"flat",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
+cym      CALL gr_fi_ecrit(1, klon,iim,jjmp1, zxfluxlat,zx_tmp_2d)
+      CALL histwrite_phy(nid_day,"flat",itau_w,zxfluxlat)
 c
       DO i = 1, klon
@@ -76,43 +71,39 @@
       ENDDO
 c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, zx_tmp_fi2d,zx_tmp_2d)
-      CALL histwrite(nid_day,"sicf",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-      CALL gr_fi_ecrit(1,klon,iim,jjmp1,zq2m,zx_tmp_2d)
-      CALL histwrite(nid_day,"q2m",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-      CALL gr_fi_ecrit(1,klon,iim,jjmp1,zu10m,zx_tmp_2d)
-      CALL histwrite(nid_day,"u10m",itau_w,zx_tmp_2d,iim*jjmp1,
-     .               ndex2d)
-c
-      CALL gr_fi_ecrit(1,klon,iim,jjmp1,zv10m,zx_tmp_2d)
-      CALL histwrite(nid_day,"v10m",itau_w,zx_tmp_2d,iim*jjmp1,
-     .               ndex2d)
+cym      CALL gr_fi_ecrit(1, klon,iim,jjmp1, zx_tmp_fi2d,zx_tmp_2d)
+      CALL histwrite_phy(nid_day,"sicf",itau_w,zx_tmp_fi2d)
+c
+cym      CALL gr_fi_ecrit(1,klon,iim,jjmp1,zq2m,zx_tmp_2d)
+      CALL histwrite_phy(nid_day,"q2m",itau_w,zq2m)
+c
+cym      CALL gr_fi_ecrit(1,klon,iim,jjmp1,zu10m,zx_tmp_2d)
+      CALL histwrite_phy(nid_day,"u10m",itau_w,zu10m)
+c
+cym      CALL gr_fi_ecrit(1,klon,iim,jjmp1,zv10m,zx_tmp_2d)
+      CALL histwrite_phy(nid_day,"v10m",itau_w,zv10m)
 c
       DO i=1, klon
        zx_tmp_fi2d(i)=SQRT(zu10m(i)*zu10m(i)+zv10m(i)*zv10m(i))
       ENDDO
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, zx_tmp_fi2d,zx_tmp_2d)
-      CALL histwrite(nid_day,"wind10m",itau_w,zx_tmp_2d,
-     $     iim*jjmp1,ndex2d)
-c
-      CALL gr_fi_ecrit(1,klon,iim,jjmp1,zx_tmp_fi2d,zx_tmp_2d)
-      CALL histwrite(nid_day,"wind10max",itau_w,zx_tmp_2d,
-     .               iim*jjmp1,ndex2d)
+cym      CALL gr_fi_ecrit(1, klon,iim,jjmp1, zx_tmp_fi2d,zx_tmp_2d)     
+      CALL histwrite_phy(nid_day,"wind10m",itau_w,zx_tmp_fi2d)
+c
+cym      CALL gr_fi_ecrit(1,klon,iim,jjmp1,zx_tmp_fi2d,zx_tmp_2d)
+      CALL histwrite_phy(nid_day,"wind10max",itau_w,zx_tmp_fi2d)
 c
       DO i=1, klon
          zx_tmp_fi2d(i) = paprs(i,1)
       ENDDO
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, zx_tmp_fi2d,zx_tmp_2d)
-      CALL histwrite(nid_day,"psol",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
+cym      CALL gr_fi_ecrit(1, klon,iim,jjmp1, zx_tmp_fi2d,zx_tmp_2d)
+      CALL histwrite_phy(nid_day,"psol",itau_w,zx_tmp_fi2d)
 c
       DO i=1, klon
          zx_tmp_fi2d(i) = (rain_fall(i) + snow_fall(i))
       ENDDO
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, zx_tmp_fi2d,zx_tmp_2d)
-      CALL histwrite(nid_day,"precip",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, snow_fall,zx_tmp_2d)
-      CALL histwrite(nid_day,"snowf",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
+cym      CALL gr_fi_ecrit(1, klon,iim,jjmp1, zx_tmp_fi2d,zx_tmp_2d)
+      CALL histwrite_phy(nid_day,"precip",itau_w,zx_tmp_fi2d)
+c
+cym      CALL gr_fi_ecrit(1, klon,iim,jjmp1, snow_fall,zx_tmp_2d)
+      CALL histwrite_phy(nid_day,"snowf",itau_w,snow_fall)
 c
 cIM: 140404   CALL gr_fi_ecrit(1, klon,iim,jjmp1, zxsnow,zx_tmp_2d)
@@ -121,40 +112,39 @@
 c    .               ndex2d)
 c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, evap,zx_tmp_2d)
-      CALL histwrite(nid_day,"evap",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, topsw,zx_tmp_2d)
-      CALL histwrite(nid_day,"tops",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, toplw,zx_tmp_2d)
-      CALL histwrite(nid_day,"topl",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, solsw,zx_tmp_2d)
-      CALL histwrite(nid_day,"sols",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, sollw,zx_tmp_2d)
-      CALL histwrite(nid_day,"soll",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, radsol,zx_tmp_2d)
-      CALL histwrite(nid_day,"radsol",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, cldl,zx_tmp_2d)
-      CALL histwrite(nid_day,"cldl",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, cldm,zx_tmp_2d)
-      CALL histwrite(nid_day,"cldm",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, cldh,zx_tmp_2d)
-      CALL histwrite(nid_day,"cldh",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, cldt,zx_tmp_2d)
-      CALL histwrite(nid_day,"cldt",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, cldq,zx_tmp_2d)
-      CALL histwrite(nid_day,"cldq",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, prw,zx_tmp_2d)
-      CALL histwrite(nid_day,"prw",itau_w,zx_tmp_2d,
-     .               iim*jjmp1,ndex2d)
+cym      CALL gr_fi_ecrit(1, klon,iim,jjmp1, evap,zx_tmp_2d)
+      CALL histwrite_phy(nid_day,"evap",itau_w,evap)
+c
+cym      CALL gr_fi_ecrit(1, klon,iim,jjmp1, topsw,zx_tmp_2d)
+      CALL histwrite_phy(nid_day,"tops",itau_w,topsw)
+c
+cym      CALL gr_fi_ecrit(1, klon,iim,jjmp1, toplw,zx_tmp_2d)
+      CALL histwrite_phy(nid_day,"topl",itau_w,toplw)
+c
+cym      CALL gr_fi_ecrit(1, klon,iim,jjmp1, solsw,zx_tmp_2d)
+      CALL histwrite_phy(nid_day,"sols",itau_w,solsw)
+c
+cym      CALL gr_fi_ecrit(1, klon,iim,jjmp1, sollw,zx_tmp_2d)
+      CALL histwrite_phy(nid_day,"soll",itau_w,sollw)
+c
+cym      CALL gr_fi_ecrit(1, klon,iim,jjmp1, radsol,zx_tmp_2d)
+      CALL histwrite_phy(nid_day,"radsol",itau_w,radsol)
+c
+cym      CALL gr_fi_ecrit(1, klon,iim,jjmp1, cldl,zx_tmp_2d)
+      CALL histwrite_phy(nid_day,"cldl",itau_w,cldl)
+c
+cym      CALL gr_fi_ecrit(1, klon,iim,jjmp1, cldm,zx_tmp_2d)
+      CALL histwrite_phy(nid_day,"cldm",itau_w,cldm)
+c
+cym      CALL gr_fi_ecrit(1, klon,iim,jjmp1, cldh,zx_tmp_2d)
+      CALL histwrite_phy(nid_day,"cldh",itau_w,cldh)
+c
+cym      CALL gr_fi_ecrit(1, klon,iim,jjmp1, cldt,zx_tmp_2d)
+      CALL histwrite_phy(nid_day,"cldt",itau_w,cldt)
+c
+cym      CALL gr_fi_ecrit(1, klon,iim,jjmp1, cldq,zx_tmp_2d)
+      CALL histwrite_phy(nid_day,"cldq",itau_w,cldq)
+c
+cym      CALL gr_fi_ecrit(1, klon,iim,jjmp1, prw,zx_tmp_2d)
+      CALL histwrite_phy(nid_day,"prw",itau_w,prw)
 
 c   Ecriture de champs dynamiques sur des niveaux de pression
@@ -173,11 +163,9 @@
      $   .OR.bb2.EQ."500".OR.bb2.EQ."200") THEN
 c
-        CALL gr_fi_ecrit(1, klon,iim,jjmp1,usumSTD(:,k,1),zx_tmp_2d)
-        CALL histwrite(nid_day,"u"//bb2,itau_w,zx_tmp_2d,
-     $       iim*jjmp1,ndex2d)
-c
-        CALL gr_fi_ecrit(1, klon,iim,jjmp1,vsumSTD(:,k,1),zx_tmp_2d)
-        CALL histwrite(nid_day,"v"//bb2,itau_w,zx_tmp_2d,
-     $       iim*jjmp1,ndex2d)
+cym        CALL gr_fi_ecrit(1, klon,iim,jjmp1,usumSTD(:,k,1),zx_tmp_2d)
+        CALL histwrite_phy(nid_day,"u"//bb2,itau_w,usumSTD(:,k,1))
+c
+cym        CALL gr_fi_ecrit(1, klon,iim,jjmp1,vsumSTD(:,k,1),zx_tmp_2d)
+        CALL histwrite_phy(nid_day,"v"//bb2,itau_w,vsumSTD(:,k,1))
 c
       ENDIF !(bb2.EQ."850".OR.bb2.EQ."700".OR.bb2.EQ."500".OR.bb2.EQ."200") THEN
@@ -187,10 +175,9 @@
       IF(bb2.EQ."500") THEN
 c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1,wsumSTD(:,k,1),zx_tmp_2d)
-      CALL histwrite(nid_day,"w"//bb2,itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1,phisumSTD(:,k,1),zx_tmp_2d)
-      CALL histwrite(nid_day,"phi"//bb2,itau_w,zx_tmp_2d,
-     $     iim*jjmp1,ndex2d)
+cym      CALL gr_fi_ecrit(1, klon,iim,jjmp1,wsumSTD(:,k,1),zx_tmp_2d)
+      CALL histwrite_phy(nid_day,"w"//bb2,itau_w,wsumSTD(:,k,1))
+c
+cym      CALL gr_fi_ecrit(1, klon,iim,jjmp1,phisumSTD(:,k,1),zx_tmp_2d)
+      CALL histwrite_phy(nid_day,"phi"//bb2,itau_w,phisumSTD(:,k,1))
 
       ENDIF !(bb2.EQ."500") THEN
@@ -198,26 +185,23 @@
       ENDDO !nlevSTD
 c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, slp,zx_tmp_2d)
-      CALL histwrite(nid_day,"slp",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-
-      CALL gr_fi_ecrit(1,klon,iim,jjmp1,cape,zx_tmp_2d)
-      CALL histwrite(nid_day,"cape_max",itau_w,zx_tmp_2d,
-     .               iim*jjmp1,ndex2d)
-c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, sollwdown,zx_tmp_2d)
-      CALL histwrite(nid_day,"solldown",itau_w,zx_tmp_2d,iim*jjmp1,
-     .               ndex2d)
+cym      CALL gr_fi_ecrit(1, klon,iim,jjmp1, slp,zx_tmp_2d)
+      CALL histwrite_phy(nid_day,"slp",itau_w,slp)
+
+cym      CALL gr_fi_ecrit(1,klon,iim,jjmp1,cape,zx_tmp_2d)
+      CALL histwrite_phy(nid_day,"cape_max",itau_w,cape)
+c
+cym      CALL gr_fi_ecrit(1, klon,iim,jjmp1, sollwdown,zx_tmp_2d)
+      CALL histwrite_phy(nid_day,"solldown",itau_w,sollwdown)
 c
       DO i=1, klon
         zx_tmp_fi2d(i)=-1*sens(i)
       ENDDO
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, zx_tmp_fi2d,zx_tmp_2d)
-      CALL histwrite(nid_day,"sens",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
+cym      CALL gr_fi_ecrit(1, klon,iim,jjmp1, zx_tmp_fi2d,zx_tmp_2d)
+      CALL histwrite_phy(nid_day,"sens",itau_w,zx_tmp_fi2d)
 c
       zx_tmp_fi2d(1 : klon) = swdn(1 : klon, 1)
 
-      CALL gr_fi_ecrit(1,klon,iim,jjmp1,zx_tmp_fi2d,zx_tmp_2d)
-      CALL histwrite(nid_day, "SWdnSFC",itau_w,zx_tmp_2d,
-     .                               iim*jjmp1,ndex2d)
+cym      CALL gr_fi_ecrit(1,klon,iim,jjmp1,zx_tmp_fi2d,zx_tmp_2d)
+      CALL histwrite_phy(nid_day, "SWdnSFC",itau_w,zx_tmp_fi2d)
 c
       IF (OCEAN.EQ.'force ') THEN
@@ -232,7 +216,6 @@
       ENDIF
       ENDDO
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, zx_tmp_fi2d,zx_tmp_2d)
-      CALL histwrite(nid_day,"lmt_bils",itau_w,
-     .     zx_tmp_2d,iim*jjmp1,ndex2d)
+cym      CALL gr_fi_ecrit(1, klon,iim,jjmp1, zx_tmp_fi2d,zx_tmp_2d)
+      CALL histwrite_phy(nid_day,"lmt_bils",itau_w, zx_tmp_fi2d)
 c
       ELSE IF (OCEAN.EQ.'slab  ') THEN
@@ -247,7 +230,6 @@
       ENDIF
       ENDDO
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, zx_tmp_fi2d,zx_tmp_2d)
-      CALL histwrite(nid_day,"slab_bils",itau_w,
-     .     zx_tmp_2d,iim*jjmp1,ndex2d)
+cym      CALL gr_fi_ecrit(1, klon,iim,jjmp1, zx_tmp_fi2d,zx_tmp_2d)
+      CALL histwrite_phy(nid_day,"slab_bils",itau_w,zx_tmp_fi2d)
 c
       DO i=1, klon
@@ -259,15 +241,12 @@
        ENDIF
       ENDDO !i=1, klon
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, zx_tmp_fi2d,zx_tmp_2d)
-      CALL histwrite(nid_day,"tslab",itau_w,zx_tmp_2d,
-     .     iim*jjmp1,ndex2d)
-c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, seaice,zx_tmp_2d)
-      CALL histwrite(nid_day,"seaice",itau_w,zx_tmp_2d,
-     .     iim*jjmp1,ndex2d)
-c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, seaice/1000.,zx_tmp_2d)
-      CALL histwrite(nid_day,"siceh",itau_w,zx_tmp_2d,
-     .     iim*jjmp1,ndex2d)
+cym      CALL gr_fi_ecrit(1, klon,iim,jjmp1, zx_tmp_fi2d,zx_tmp_2d)
+      CALL histwrite_phy(nid_day,"tslab",itau_w,zx_tmp_fi2d)
+c
+cym      CALL gr_fi_ecrit(1, klon,iim,jjmp1, seaice,zx_tmp_2d)
+      CALL histwrite_phy(nid_day,"seaice",itau_w,seaice)
+c
+cym      CALL gr_fi_ecrit(1, klon,iim,jjmp1, seaice/1000.,zx_tmp_2d)
+      CALL histwrite_phy(nid_day,"siceh",itau_w,seaice/1000.)
 c
       ENDIF !(OCEAN.EQ.'slab  ') THEN
@@ -281,7 +260,6 @@
       ENDDO
 c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, zx_tmp_fi2d,zx_tmp_2d)
-      CALL histwrite(nid_day,"fluxo",itau_w,zx_tmp_2d,
-     .     iim*jjmp1,ndex2d)
+cym     CALL gr_fi_ecrit(1, klon,iim,jjmp1, zx_tmp_fi2d,zx_tmp_2d)
+      CALL histwrite_phy(nid_day,"fluxo",itau_w,zx_tmp_fi2d)
 c
       DO i=1, klon
@@ -293,7 +271,6 @@
       ENDDO
 c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, zx_tmp_fi2d,zx_tmp_2d)
-      CALL histwrite(nid_day,"fluxg",itau_w,zx_tmp_2d,
-     .     iim*jjmp1,ndex2d)
+cym      CALL gr_fi_ecrit(1, klon,iim,jjmp1, zx_tmp_fi2d,zx_tmp_2d)
+      CALL histwrite_phy(nid_day,"fluxg",itau_w,zx_tmp_fi2d)
 c
       ENDIF !lev_histday.GE.1
@@ -301,9 +278,9 @@
       IF(lev_histday.GE.2) THEN
 c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, bils,zx_tmp_2d)
-      CALL histwrite(nid_day,"bils",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, fder,zx_tmp_2d)
-      CALL histwrite(nid_day,"fder",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
+cym      CALL gr_fi_ecrit(1, klon,iim,jjmp1, bils,zx_tmp_2d)
+      CALL histwrite_phy(nid_day,"bils",itau_w, bils)
+c
+cym      CALL gr_fi_ecrit(1, klon,iim,jjmp1, fder,zx_tmp_2d)
+      CALL histwrite_phy(nid_day,"fder",itau_w,fder)
 c
       ENDIF !lev_histday.GE.2
@@ -317,31 +294,24 @@
 c Champs 3D:
 c
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, t_seri, zx_tmp_3d)
-      CALL histwrite(nid_day,"temp",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, qx(1,1,ivap), zx_tmp_3d)
-      CALL histwrite(nid_day,"ovap",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, zphi, zx_tmp_3d)
-      CALL histwrite(nid_day,"geop",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, u_seri, zx_tmp_3d)
-      CALL histwrite(nid_day,"vitu",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, v_seri, zx_tmp_3d)
-      CALL histwrite(nid_day,"vitv",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, omega, zx_tmp_3d)
-      CALL histwrite(nid_day,"vitw",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, pplay, zx_tmp_3d)
-      CALL histwrite(nid_day,"pres",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
+cym      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, t_seri, zx_tmp_3d)
+      CALL histwrite_phy(nid_day,"temp",itau_w,t_seri)
+c
+cym      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, qx(1,1,ivap), zx_tmp_3d)
+      CALL histwrite_phy(nid_day,"ovap",itau_w,qx(:,:,ivap))
+c
+cym      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, zphi, zx_tmp_3d)
+      CALL histwrite_phy(nid_day,"geop",itau_w,zphi)
+c
+cym      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, u_seri, zx_tmp_3d)
+      CALL histwrite_phy(nid_day,"vitu",itau_w,u_seri)
+c
+cym      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, v_seri, zx_tmp_3d)
+      CALL histwrite_phy(nid_day,"vitv",itau_w,v_seri)
+c
+cym      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, omega, zx_tmp_3d)
+      CALL histwrite_phy(nid_day,"vitw",itau_w,omega)
+c
+cym      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, pplay, zx_tmp_3d)
+      CALL histwrite_phy(nid_day,"pres",itau_w,pplay)
 c
       ENDIF !lev_histday.GE.3
